# Name:        CTrun v1.2
#
# Author:      JoeyT2007
#
# Description: Allows CT's to pick up the bomb and run away.
#
# Bugs:        1. CT's can't drop the bomb the first time, they need to drop it twice. After that it will work fine.
#
# Credits:     Creator         JoeyT2007
#
#              Idea            SuperDave
#
#              Thanks          R`SiN
#                              GODJonez
#                              Errant
#                              Einlanzers
#                              Sniperhmm
#                              Venjax

import es
from es import server_var
import playerlib, gamethread, vecmath, random

####SETTINGS####
ctrun_announcebomb = es.ServerVar("ctrun_announcebomb", "0", "Announce when the bomb has been picked up or dropped? Can be spammy.")
ctrun_allowplant = es.ServerVar("ctrun_allowplant", "0", "Allow CT's to plant the bomb?")
ctrun_c4_beacon = es.ServerVar("ctrun_c4_beacon", "1", "Shows a green beacon around the bomb when dropped. Easier to find.")
ctrun_autoreturn = es.ServerVar("ctrun_autoreturn", "1", "Return the bomb if it gets lost?")
ctrun_losttimer = es.ServerVar("ctrun_losttimer", "30", "How long before the bomb is returned.")
################

ctrun = es.ServerVar("ctrun", "1", "Activate/Deactivate the mod.")
ctrun_c4 = 0
ctrun_c4_location = 0
ctrun_c4_dropped = 0
ctrun_player = 0
targetid = 0
target = 0
ctrun_player_location = 0
ctrun_player_name = 0
ctrun_return_userid = 0
ctrun_return_name = 0
ctrun_playerlist = 0
ctrun_distance = 0
ctrun_planted_c4 = 0
ctrun_immune = -1
ctrun_c4_count = 0
ctrun_c4_temp = 0
ctrun_c4_list = 0
ctrun_player_team = 0
ctrun_player_alive = es.ServerVar("ctrun_player_alive", 0)
ctrun_ver = es.ServerVar("ctrun_ver", "1.2", "Version of CTrun that you are using.")
ctrun_ver.makepublic()
ctrun_c4location = 0
ctrun_randomspawn = 0
ctrun_randomspawnlocation = 0
ctrun_spawns = 0
ctrun_randomint = 0
ctrun_spawnlocations = 0
ctrun_noannounce = 0
x = 0

info = es.AddonInfo()
info.name = "CTrun"
info.version = "1.2"
info.author = "JoeyT2007"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?p=162585"
info.description = "Allows CT's to pick up the bomb and run away."
info.basename = "ctrun"

def load():
    ctrun_map = es.ServerVar("eventscripts_currentmap")
    if str(ctrun_map) > 1:
        global ctrun
        if "de_" in str(ctrun_map):
            ctrun = 1
            es.set('ctrun', 1)
            checkc4()
        else:
            ctrun = 0
            es.set('ctrun', 0)

def es_map_start(event_var):
    ctrun_map = es.ServerVar("eventscripts_currentmap")
    if str(ctrun_map) > 1:
        global ctrun
        if "de_" in str(ctrun_map):
            ctrun = 1
            es.set('ctrun', 1)
        else:
            ctrun = 0
            es.set('ctrun', 0)

def unload():
    gamethread.cancelDelayed("checkc4loop")
    gamethread.cancelDelayed("playerhasc4")
    gamethread.cancelDelayed("undoimmunity")
    gamethread.cancelDelayed("lostbomb")

def round_start(event_var):
    global ctrun_noannounce
    ctrun_noannounce = 1
    gamethread.cancelDelayed("checkc4loop")
    gamethread.cancelDelayed("playerhasc4")
    gamethread.cancelDelayed("undoimmunity")
    if ctrun == 1:
        es.msg("#multi", "#green[CTrun]#lightgreen CT's #defaultcan pickup the bomb when dropped.")
    setimmunity()
    checkc4()

def round_end(event_var):
    gamethread.cancelDelayed("lostbomb")
    if ctrun == 1:
        if ctrun_player != 0:
            es.server.cmd("est_team %i 3" % ctrun_player)

def checkc4():
    if ctrun == 1:
        ctrun_c4_list = es.createentitylist('weapon_c4')
        ctrun_count = len(ctrun_c4_list)
        if ctrun_count == 1:
            ctrun_planted_c4 = es.getentityindex("planted_c4")
            if ctrun_planted_c4 == -1:
                global ctrun_c4
                ctrun_c4 = es.getentityindex("weapon_c4")
                if ctrun_c4 != -1:
                    ctrun_c4_dropped = es.getindexprop(ctrun_c4, "CBaseEntity.m_hOwnerEntity")
                    if ctrun_c4_dropped == -1:
                        ctrun_c4_location = es.getindexprop(ctrun_c4, "CBaseEntity.m_vecOrigin")
                        ctrun_playerlist = playerlib.getPlayerList('#all')
                        for targetid in ctrun_playerlist:
                            if (not int(targetid.attributes['isdead'])) and int(targetid.attributes['teamid'])==3:
                                if int(targetid) != ctrun_immune:
                                    target = int(targetid)
                                    ctrun_player_location = vecmath.vector((targetid.attributes['x'], targetid.attributes['y'], targetid.attributes['z']))
                                    ctrun_distance = vecmath.distance(ctrun_c4_location, ctrun_player_location)
                                    if ctrun_distance <= 100:
                                       pickupc4(target)
    gamethread.delayedname(0.2, "checkc4loop", checkc4)

def pickupc4(ctrun_player):
    es.server.cmd("est_team %i 2" % ctrun_player)
    es.give(ctrun_player, "weapon_c4")
    es.remove(ctrun_c4)
    global ctrun_c4
    ctrun_c4 = es.ServerVar("eventscripts_lastgive")
    es.server.cmd("es_delayed 0.1 est_team %i 3" % ctrun_player)
    gamethread.cancelDelayed("playerhasc4")
    playerhasc4(ctrun_player)

def bomb_beginplant(event_var):
    if ctrun_allowplant == 0:
        ctrun_player_team = 0
        ctrun_player_team = es.getplayerteam(event_var["userid"])
        if ctrun_player_team == 3:
            es.remove("weapon_c4")
            es.server.cmd("est_team %i 2" % int(event_var["userid"]))
            global ctrun_noannounce
            ctrun_noannounce = 1
            es.give(int(event_var["userid"]), "weapon_c4")
            global ctrun_c4
            ctrun_c4 = es.ServerVar("eventscripts_lastgive")
            es.server.cmd("es_delayed 0.1 est_team %i 3" % int(event_var["userid"]))
            es.tell(event_var["userid"], "#multi", "#green[CTrun]#default You are not allowed to plant the #lightgreenbomb#default.")

def playerhasc4(ctrun_player):
    if ctrun == 1:
        ctrun_player_alive = es.ServerVar("ctrun_player_alive", 0)
        es.server.cmd("est_isalive ctrun_player_alive %i" % ctrun_player)
        if ctrun_player_alive == 1:
            ctrun_hasc4 = 0
            es.server.cmd("playerget ctrun_hasc4 %i" % ctrun_player)
            if ctrun_hasc4 == 1:
                gamethread.delayedname(0.1, "playerhasc4", playerhasc4, ctrun_player)
            else:
                global ctrun_immune
                ctrun_immune = ctrun_player
                gamethread.delayedname(2.5, "undoimmunity", setimmunity)

def setimmunity():
    global ctrun_immune
    ctrun_immune = -1

def bomb_pickup(event_var):
    gamethread.cancelDelayed("beacon")
    if ctrun_autoreturn == 1:
       gamethread.cancelDelayed("lostbomb")
    ctrun_player_name = es.getplayername(event_var["userid"])
    if ctrun == 1:
        if ctrun_announcebomb == 1:
            if ctrun_noannounce != 1:
                es.msg("#multi", "#green[CTrun]#default The #lightgreenbomb#default was picked up by#lightgreen %s#default, find him!" % ctrun_player_name)
            else:
                global ctrun_noannounce
                ctrun_noannounce = 0

def bomb_dropped(event_var):
    gamethread.delayedname(1.5, "beacon", beacon)
    if ctrun_autoreturn == 1:
        gamethread.delayedname(ctrun_losttimer, "lostbomb", lostbomb)
    ctrun_player_name = es.getplayername(event_var["userid"])
    if ctrun == 1:
        if ctrun_announcebomb == 1:
            if ctrun_noannounce != 1:
                es.msg("#multi", "#green[CTrun]#default The #lightgreenbomb#default was dropped by#lightgreen %s#default, find it!" % ctrun_player_name)
            else:
                global ctrun_noannounce
                ctrun_noannounce = 0

def lostbomb():
    if ctrun == 1:
        if ctrun_autoreturn == 1:
            ctrun_playerlist = playerlib.getPlayerList('#alive')
            ctrun_return_userid = random.choice(ctrun_playerlist)
            ctrun_return_userid = int(ctrun_return_userid)
            ctrun_return_name = es.getplayername(ctrun_return_userid)
            es.msg("#multi", "#green[CTrun]#default The #lightgreenbomb#default was lost, it has been given to#lightgreen %s" % ctrun_return_name)
            ctrun_return_team = es.getplayerteam(ctrun_return_userid)
            if ctrun_return_team == 3:
                pickupc4(ctrun_return_userid)
            if ctrun_return_team == 2:
                es.remove(ctrun_c4)
                global ctrun_noannounce
                ctrun_noannounce = 1
                es.give(ctrun_return_userid, "weapon_c4")
                global ctrun_c4
                ctrun_c4 = es.ServerVar("eventscripts_lastgive")

def beacon():
    if ctrun == 1:
        if ctrun_c4_beacon == 1:
            if ctrun_c4 != 0:
                ctrun_c4_location = es.getindexprop(ctrun_c4, "CBaseEntity.m_vecOrigin")
                (ctrun_c4_x, ctrun_c4_y, ctrun_c4_z) = es.splitvectorstring(ctrun_c4_location)
                es.server.cmd('est_effect 10 #all 0 "sprites/lgtning.vmt" %s %s %s 0 125 1 1 1 1 0 255 0 255 0' % (str(ctrun_c4_x), str(ctrun_c4_y), str(ctrun_c4_z)))
    gamethread.delayedname(0.5, "beacon", beacon)